
package com.archeus.test;

import java.net.MalformedURLException;
import java.util.Collection;
import java.util.HashMap;
import javax.xml.namespace.QName;
import org.codehaus.xfire.XFireRuntimeException;
import org.codehaus.xfire.aegis.AegisBindingProvider;
import org.codehaus.xfire.annotations.AnnotationServiceFactory;
import org.codehaus.xfire.annotations.jsr181.Jsr181WebAnnotations;
import org.codehaus.xfire.client.XFireProxyFactory;
import org.codehaus.xfire.jaxb2.JaxbTypeRegistry;
import org.codehaus.xfire.service.Endpoint;
import org.codehaus.xfire.service.Service;
import org.codehaus.xfire.soap.AbstractSoapBinding;
import org.codehaus.xfire.transport.TransportManager;

public class InflectorServiceServiceClient {

	private static XFireProxyFactory proxyFactory = new XFireProxyFactory();

	private HashMap endpoints = new HashMap();

	private Service service0;

	public InflectorServiceServiceClient() {
		create0();
		Endpoint InflectorEP = service0.addEndpoint(new QName(
				"http://www.archeus.ro/lingvistica/services/Inflector",
				"Inflector"), new QName(
				"http://www.archeus.ro/lingvistica/services/Inflector",
				"InflectorSoapBinding"),
				"http://www.archeus.ro/lingvistica/services/Inflector");
		endpoints.put(new QName(
				"http://www.archeus.ro/lingvistica/services/Inflector",
				"Inflector"), InflectorEP);
		Endpoint InflectorServiceLocalEndpointEP = service0.addEndpoint(
				new QName(
						"http://www.archeus.ro/lingvistica/services/Inflector",
						"InflectorServiceLocalEndpoint"), new QName(
						"http://www.archeus.ro/lingvistica/services/Inflector",
						"InflectorServiceLocalBinding"),
				"xfire.local://InflectorServiceService");
		endpoints.put(new QName(
				"http://www.archeus.ro/lingvistica/services/Inflector",
				"InflectorServiceLocalEndpoint"),
				InflectorServiceLocalEndpointEP);
	}

	public Object getEndpoint(Endpoint endpoint) {
		try {
			return proxyFactory.create((endpoint).getBinding(), (endpoint)
					.getUrl());
		} catch (MalformedURLException e) {
			throw new XFireRuntimeException("Invalid URL", e);
		}
	}

	public Object getEndpoint(QName name) {
		Endpoint endpoint = ((Endpoint) endpoints.get((name)));
		if ((endpoint) == null) {
			throw new IllegalStateException("No such endpoint!");
		}
		return getEndpoint((endpoint));
	}

	public Collection getEndpoints() {
		return endpoints.values();
	}

	private void create0() {
		TransportManager tm = (org.codehaus.xfire.XFireFactory.newInstance()
				.getXFire().getTransportManager());
		HashMap props = new HashMap();
		props.put("annotations.allow.interface", true);
		AnnotationServiceFactory asf = new AnnotationServiceFactory(
				new Jsr181WebAnnotations(), tm, new AegisBindingProvider(
						new JaxbTypeRegistry()));
		asf.setBindingCreationEnabled(false);
		service0 = asf.create((com.archeus.test.InflectorService.class), props);
		{
			AbstractSoapBinding soapBinding = asf
					.createSoap11Binding(
							service0,
							new QName(
									"http://www.archeus.ro/lingvistica/services/Inflector",
									"InflectorSoapBinding"),
							"http://schemas.xmlsoap.org/soap/http");
		}
		{
			AbstractSoapBinding soapBinding = asf
					.createSoap11Binding(
							service0,
							new QName(
									"http://www.archeus.ro/lingvistica/services/Inflector",
									"InflectorServiceLocalBinding"),
							"urn:xfire:transport:local");
		}
	}

	public InflectorService getInflector() {
		return ((InflectorService) (this).getEndpoint(new QName(
				"http://www.archeus.ro/lingvistica/services/Inflector",
				"Inflector")));
	}

	public InflectorService getInflector(String url) {
		InflectorService var = getInflector();
		org.codehaus.xfire.client.Client.getInstance(var).setUrl(url);
		return var;
	}

	public InflectorService getInflectorServiceLocalEndpoint() {
		return ((InflectorService) (this).getEndpoint(new QName(
				"http://www.archeus.ro/lingvistica/services/Inflector",
				"InflectorServiceLocalEndpoint")));
	}

	public InflectorService getInflectorServiceLocalEndpoint(String url) {
		InflectorService var = getInflectorServiceLocalEndpoint();
		org.codehaus.xfire.client.Client.getInstance(var).setUrl(url);
		return var;
	}

	public static void main(String[] args) {

		InflectorServiceServiceClient client = new InflectorServiceServiceClient();

		//create a default service endpoint
		InflectorService service = client.getInflector();

		//*********************************************
		//*********************************************

		//*********************************************
		// codul de pana aici a fost generat automat de IDE (Eclipse)
		//*********************************************

		String lang = "ro";
		String word = "test";
		System.out.println(service.inflectWord(word, lang));
		
		//*********************************************
		//*********************************************
		System.out.println("Done");
		System.exit(0);
	}

}
